
// PCAcceptorDlg.cpp : implementation file
//----------------------------------------
#include "stdafx.h"
#include "PCAcceptor.h"
#include "PCAcceptorDlg.h"
#include "EditPriceDlg.h"
#include "ConnectionDlg.h"
#include "InterfaceSocket.h"
#include "AboutDlg.h"
#include "Identifier.h"
#include "AcceptorControlDlg.h"
#include "TubeStatusDlg.h"
#include "SetupDlg.h"
#include "IdentificationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CPCAcceptorDlg dialog
//----------------------

CPCAcceptorDlg::CPCAcceptorDlg(CWnd* pParent) : CDialog(CPCAcceptorDlg::IDD, pParent)
//===================================================================================
{
	//{{AFX_DATA_INIT(CPCAcceptorDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_AcceptorState=ACCEPTOR_Idle;
	m_PreviousState=ACCEPTOR_Idle;
	m_bReset=false;
	m_wCoinTypeEnable=0;
	m_wCoinTypeDispense=0;
	m_dwFeatureEnable=0;
	m_dwAcceptorWaitPolls=10;
	m_dwAccumulator=0;
	memset(&m_AcceptorStatus,0,sizeof(ACCEPTOR_STATUS));
	memset(&m_AcceptorTubeStatus,0,sizeof(ACCEPTOR_TUBESTATUS));
	memset(&m_AcceptorIdentification,0,sizeof(ACCEPTOR_IDENTIFICATION));
}

void CPCAcceptorDlg::DoDataExchange(CDataExchange* pDX)
//=====================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCAcceptorDlg)
	DDX_Control(pDX, IDC_DISPLAY, m_Display);
	DDX_Control(pDX, IDC_PRICE_9, m_Price9);
	DDX_Control(pDX, IDC_PRICE_8, m_Price8);
	DDX_Control(pDX, IDC_PRICE_7, m_Price7);
	DDX_Control(pDX, IDC_PRICE_6, m_Price6);
	DDX_Control(pDX, IDC_PRICE_5, m_Price5);
	DDX_Control(pDX, IDC_PRICE_4, m_Price4);
	DDX_Control(pDX, IDC_PRICE_3, m_Price3);
	DDX_Control(pDX, IDC_PRICE_2, m_Price2);
	DDX_Control(pDX, IDC_PRICE_1, m_Price1);
	DDX_Control(pDX, IDC_PRICE_0, m_Price0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCAcceptorDlg, CDialog)
	//{{AFX_MSG_MAP(CPCAcceptorDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_EDIT_PRICES, OnEditPrices)
	ON_COMMAND(IDM_CONNECTION, OnConnection)
	ON_COMMAND(IDM_ABOUT, OnAbout)
	ON_WM_DESTROY()
	ON_COMMAND(IDM_ACCEPTOR_CONTROL, OnAcceptorControl)
	ON_COMMAND(IDM_ACCEPTOR_SETUP, OnAcceptorSetup)
	ON_COMMAND(IDM_ACCEPTOR_IDENTIFICATION, OnAcceptorIdentification)
	ON_COMMAND(IDM_TUBE_STATUS, OnTubeStatus)
	ON_BN_CLICKED(IDC_SELECTION_0, OnSelection0)
	ON_BN_CLICKED(IDC_SELECTION_1, OnSelection1)
	ON_BN_CLICKED(IDC_SELECTION_2, OnSelection2)
	ON_BN_CLICKED(IDC_SELECTION_3, OnSelection3)
	ON_BN_CLICKED(IDC_SELECTION_4, OnSelection4)
	ON_BN_CLICKED(IDC_SELECTION_5, OnSelection5)
	ON_BN_CLICKED(IDC_SELECTION_6, OnSelection6)
	ON_BN_CLICKED(IDC_SELECTION_7, OnSelection7)
	ON_BN_CLICKED(IDC_SELECTION_8, OnSelection8)
	ON_BN_CLICKED(IDC_SELECTION_9, OnSelection9)
	ON_BN_CLICKED(IDC_PAYOUT, OnPayout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CPCAcceptorDlg::UpdateDisplay()
//==================================
{
	CString strDisplay;
	strDisplay.Format(_T("%u.%02u"),m_dwAccumulator/100,m_dwAccumulator%100);
	m_Display.SetWindowText(strDisplay);
}

// CPCAcceptorDlg message handlers
//--------------------------------

BOOL CPCAcceptorDlg::OnInitDialog()
//=================================
{
	DWORD dwIndex;
	DWORD dwPrice;
	CString strText;
	BYTE pData[16];
	CPCAcceptorApp* pApp=(CPCAcceptorApp*)AfxGetApp();
	CDialog::OnInitDialog();
	m_Display.SetWindowText(_T("0.00"));
	for (dwIndex=0; dwIndex<10; dwIndex++)
	{
		strText.Format(_T("Price_%02u"),dwIndex);
		dwPrice=pApp->GetProfileInt(REG_PRICES,strText,100);
		strText.Format(_T("%u.%02u"),dwPrice/100,dwPrice%100);
		SetDlgItemText(IDC_PRICE_0+dwIndex,strText);
	}

	// Enable polling the coin acceptor
	//---------------------------------
	if (pApp->IsConnected())
	{
		pData[0]=0x08; // Option type
		pData[1]=0x03; // Option length
		pData[2]=ADR_CHANGER|CMD_CHANGER_POLL; // Option data, (Acceptor poll)
		pApp->GetControlSocket()->Send(pData,3);
	}

	// Enable polling the card reader
	//-------------------------------
	if (pApp->IsConnected())
	{
		pData[0]=0x08; // Option type
		pData[1]=0x03; // Option length
		pData[2]=ADR_READER|CMD_POLL; // Option data, (Card reader poll)
		pApp->GetControlSocket()->Send(pData,3);
	}


/*
	// Enable polling the bill validator
	//----------------------------------
	if (pApp->IsConnected())
	{
		pData[0]=0x08; // Option type
		pData[1]=0x03; // Option length
		pData[2]=ADR_BILL|CMD_BILL_POLL; // Option data, (Bill validator poll)
		pApp->GetControlSocket()->Send(pData,3);
	}
*/

	// Set the icon for this dialog.
	// The framework does this automatically
	// when the application's main window is not a dialog
	//---------------------------------------------------
	SetIcon(m_hIcon, TRUE);	// Set big icon
	SetIcon(m_hIcon, FALSE); // Set small icon
	return TRUE; // return TRUE  unless you set the focus to a control
}

void CPCAcceptorDlg::OnDestroy() 
//==============================
{
	BYTE pData[16];
	CPCAcceptorApp* pApp=(CPCAcceptorApp*)AfxGetApp();
	CDialog::OnDestroy();
	
	// Disable polling the coin acceptor
	//----------------------------------
	if (pApp->IsConnected())
	{
		pData[0]=0x08; // Option type
		pData[1]=0x03; // Option length
		pData[2]=0; // Option data, (No poll)
		pApp->GetControlSocket()->Send(pData,3);
	}
}

void CPCAcceptorDlg::SetState(ACCEPTOR_STATE AcceptorState)
//=========================================================
{
	if (AcceptorState==ACCEPTOR_Idle)
	{
		m_dwAcceptorWaitPolls=10;
	}
	m_AcceptorState=AcceptorState;
}

ACCEPTOR_STATUS* CPCAcceptorDlg::GetStatus()
//==========================================
{
	return &m_AcceptorStatus;
}

ACCEPTOR_TUBESTATUS* CPCAcceptorDlg::GetTubeStatus()
//==================================================
{
	return &m_AcceptorTubeStatus;
}

ACCEPTOR_IDENTIFICATION* CPCAcceptorDlg::GetIdentification()
//==========================================================
{
	return &m_AcceptorIdentification;
}

void CPCAcceptorDlg::SellItem(DWORD dwIndex)
//==========================================
{
	DWORD dwPrice;
	CString strText;
	CWinApp* pApp=AfxGetApp();
	strText.Format(_T("Price_%02u"),dwIndex);
	dwPrice=pApp->GetProfileInt(REG_PRICES,strText,100);
	if (dwPrice<=m_dwAccumulator)
	{
		m_dwAccumulator-=dwPrice;
		MessageBeep(250);
		UpdateDisplay();
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CPCAcceptorDlg::OnPaint() 
//============================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CPCAcceptorDlg::OnQueryDragIcon()
//=======================================
{
	return (HCURSOR)m_hIcon;
}

void CPCAcceptorDlg::Received(DWORD dwPort, BYTE* pData, DWORD dwLength)
//======================================================================
{
	BYTE pFrame[MAX_FRAME_LENGTH];
	CPCAcceptorApp* pApp=(CPCAcceptorApp*)AfxGetApp();
	if ((*pData&0xF8)!=ADR_CHANGER)
	{
		return;
	}
#ifdef _DEBUG
	if (m_AcceptorState!=m_PreviousState)
	{
		TRACE(_T("Changed state: %u ==> %u\r\n"),m_PreviousState,m_AcceptorState);
		m_PreviousState=m_AcceptorState;
	}
#endif
	switch (m_AcceptorState)
	{
		case ACCEPTOR_Idle:
		{
			if (m_dwAcceptorWaitPolls>0)
			{
				m_dwAcceptorWaitPolls--;
			}
			else
			{
				m_bReset=false;
				m_AcceptorState=ACCEPTOR_Reset;
			}
			break;
		}
		case ACCEPTOR_Reset:
		{
			if (m_dwAcceptorWaitPolls>0)
			{
				m_dwAcceptorWaitPolls--;
				break;
			}
			if (dwLength==1 && m_bReset)
			{
				m_AcceptorState=ACCEPTOR_Setup;
				break;
			}
			if (!m_bReset)
			{
				pFrame[0]=ADR_CHANGER|CMD_RESET;
				pApp->GetCommunicationSocket()->Send(pFrame,1);
				m_bReset=true;
				m_dwAcceptorWaitPolls=3;
			}
			break;
		}
		case ACCEPTOR_Setup:
		{
			if (dwLength>7)
			{
				memcpy(&m_AcceptorStatus,pData+1,sizeof(ACCEPTOR_STATUS));
				m_AcceptorState=ACCEPTOR_Identification;
			}
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				pFrame[0]=ADR_CHANGER|CMD_SETUP;
				pApp->GetCommunicationSocket()->Send(pFrame,1);
			}
			break;
		}
		case ACCEPTOR_Identification:
		{
			if (dwLength>7)
			{
				memcpy(&m_AcceptorIdentification.strManufacturerCode,pData+1,3);
				m_AcceptorIdentification.strManufacturerCode[3]=0;
				memcpy(&m_AcceptorIdentification.strSerialNumber,pData+4,12);
				m_AcceptorIdentification.strSerialNumber[12]=0;
				memcpy(&m_AcceptorIdentification.strModelNumber,pData+16,12);
				m_AcceptorIdentification.strModelNumber[12]=0;
				memcpy(&m_AcceptorIdentification.wSoftwareVersion,pData+28,2);
				memcpy(&m_AcceptorIdentification.dwOptinalFeatures,pData+30,4);
				m_AcceptorState=ACCEPTOR_FeatureEnable;
			}
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				pFrame[0]=ADR_CHANGER|CMD_EXPANSION;
				pFrame[1]=SUB_IDENTIFICATION;
				pApp->GetCommunicationSocket()->Send(pFrame,2);
			}
			break;
		}
		case ACCEPTOR_FeatureEnable:
		{
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				m_dwFeatureEnable=pApp->GetProfileInt(REG_ACCEPTOR_CONTROL_DLG,REG_FEATURE_ENABLE,0);
				pFrame[0]=ADR_CHANGER|CMD_EXPANSION;
				pFrame[1]=SUB_CHANGER_FEATURE_ENABLE;
				pFrame[2]=(BYTE)(m_dwFeatureEnable>>24);
				pFrame[3]=(BYTE)(m_dwFeatureEnable>>16);
				pFrame[4]=(BYTE)(m_dwFeatureEnable>>8);
				pFrame[5]=(BYTE)m_dwFeatureEnable;
				pApp->GetCommunicationSocket()->Send(pFrame,6);
				m_AcceptorState=ACCEPTOR_TubeStatus;
			}
			break;
		}
		case ACCEPTOR_TubeStatus:
		{
			if (dwLength>7)
			{
				memcpy(&m_AcceptorTubeStatus,pData+1,sizeof(ACCEPTOR_TUBESTATUS));
				m_AcceptorState=ACCEPTOR_CoinTypeEnable;
			}
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				pFrame[0]=ADR_CHANGER|CMD_TUBE_STATUS;
				pApp->GetCommunicationSocket()->Send(pFrame,1);
			}
			break;
		}
		case ACCEPTOR_CoinTypeEnable:
		{
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				m_wCoinTypeEnable=pApp->GetProfileInt(REG_ACCEPTOR_CONTROL_DLG,REG_COIN_ACCEPT,0);
				m_wCoinTypeDispense=pApp->GetProfileInt(REG_ACCEPTOR_CONTROL_DLG,REG_COIN_DISPENSE,0);
				pFrame[0]=ADR_CHANGER|CMD_COIN_TYPE;
				pFrame[1]=(BYTE)(m_wCoinTypeEnable>>8);
				pFrame[2]=(BYTE)m_wCoinTypeEnable;
				pFrame[3]=(BYTE)(m_wCoinTypeDispense>>8);
				pFrame[4]=(BYTE)m_wCoinTypeDispense;
				pApp->GetCommunicationSocket()->Send(pFrame,5);
				m_AcceptorState=ACCEPTOR_Polling;
			}
			break;
		}
		case ACCEPTOR_CoinTypeDisable:
		{
			if (dwLength==2 && pData[1]==0x0B)
			{
				m_dwAcceptorWaitPolls=10;
				m_AcceptorState=ACCEPTOR_Idle;
			}
			if (dwLength==1)
			{
				pFrame[0]=ADR_CHANGER|CMD_COIN_TYPE;
				pFrame[1]=0;
				pFrame[2]=0;
				pFrame[3]=0;
				pFrame[4]=0;
				pApp->GetCommunicationSocket()->Send(pFrame,5);
				m_AcceptorState=ACCEPTOR_Polling;
			}
			break;
		}
		case ACCEPTOR_Polling:
		{
			if (dwLength>1)
			{
				if ((pData[1]&0xC0)==0x40)
				{
					m_dwAccumulator+=(m_AcceptorStatus.CoinTypeCredit[pData[1]&0x0F])*m_AcceptorStatus.ScalingFactor;
					UpdateDisplay();
					pFrame[0]=ADR_CHANGER|CMD_TUBE_STATUS;
					pApp->GetCommunicationSocket()->Send(pFrame,1);
					m_AcceptorState=ACCEPTOR_TubeStatus;
				}
				if ((pData[1]&0x0F)==0x0B)
				{
					m_AcceptorState=ACCEPTOR_Idle;
				}
			}
			break;
		}
		case ACCEPTOR_Payout:
		{
			pFrame[0]=ADR_CHANGER|CMD_EXPANSION;
			pFrame[1]=SUB_ALTERNATIVE_PAYOUT;
			pFrame[2]=(BYTE)(m_dwAccumulator/(DWORD)m_AcceptorStatus.ScalingFactor);
			pApp->GetCommunicationSocket()->Send(pFrame,3);
			m_dwAccumulator=0;
			UpdateDisplay();
			m_AcceptorState=ACCEPTOR_Polling;
			break;
		}
	}
}

void CPCAcceptorDlg::OnEditPrices() 
//=================================
{
	DWORD dwIndex;
	DWORD dwPrice;
	CString strText;
	CWinApp* pApp=AfxGetApp();
	CEditPriceDlg EditPriceDlg;
	if (EditPriceDlg.DoModal()==IDOK)
	{
		for (dwIndex=0; dwIndex<10; dwIndex++)
		{
			strText.Format(_T("Price_%02u"),dwIndex);
			dwPrice=pApp->GetProfileInt(REG_PRICES,strText,100);
			strText.Format(_T("%u.%02u"),dwPrice/100,dwPrice%100);
			SetDlgItemText(IDC_PRICE_0+dwIndex,strText);
		}
	}
}

void CPCAcceptorDlg::OnConnection() 
//=================================
{
	CConnectionDlg ConnectionDlg;
	ConnectionDlg.DoModal();
}

void CPCAcceptorDlg::OnAbout() 
//============================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

void CPCAcceptorDlg::OnAcceptorControl() 
//======================================
{
	CAcceptorControlDlg AcceptorControlDlg;
	AcceptorControlDlg.DoModal();	
}

void CPCAcceptorDlg::OnAcceptorSetup() 
//====================================
{
	CSetupDlg SetupDlg;
	SetupDlg.DoModal();
}

void CPCAcceptorDlg::OnAcceptorIdentification() 
//=============================================
{
	CIdentificationDlg IdentificationDlg;
	IdentificationDlg.DoModal();
}

void CPCAcceptorDlg::OnTubeStatus() 
//=================================
{
	CTubeStatusDlg TubeStatusDlg;
	TubeStatusDlg.DoModal();
}

void CPCAcceptorDlg::OnSelection0() 
//=================================
{
	SellItem(0);
}

void CPCAcceptorDlg::OnSelection1() 
//=================================
{
	SellItem(1);
}

void CPCAcceptorDlg::OnSelection2() 
//=================================
{
	SellItem(2);
}

void CPCAcceptorDlg::OnSelection3() 
//=================================
{
	SellItem(3);
}

void CPCAcceptorDlg::OnSelection4() 
//=================================
{
	SellItem(4);
}

void CPCAcceptorDlg::OnSelection5() 
//=================================
{
	SellItem(5);
}

void CPCAcceptorDlg::OnSelection6() 
//=================================
{
	SellItem(6);
}

void CPCAcceptorDlg::OnSelection7() 
//=================================
{
	SellItem(7);
}

void CPCAcceptorDlg::OnSelection8() 
//=================================
{
	SellItem(8);
}

void CPCAcceptorDlg::OnSelection9() 
//=================================
{
	SellItem(9);
}

void CPCAcceptorDlg::OnPayout() 
//=============================
{
	SetState(ACCEPTOR_Payout);
}
